
!RGMethodDefinition methodsFor: '*Ring-Monticello' stamp: 'CamilloBruni 2/28/2012 14:28'!
asMCMethodDefinitionFromFile: file
	"Creates a MCMethodDefinition from a source file assuming the current metod isActive.
	This is significantly faster than the asMCMethodDefinition as it does not open the source file pointer twice; for the sourceCode and the timeStamp"
	| compiledMethod methodClass|
	compiledMethod := self compiledMethod.
	methodClass := compiledMethod methodClass.
	
   ^ MCMethodDefinition
		className: methodClass theNonMetaClass name
 	   	classIsMeta: methodClass isMeta
		selector: compiledMethod selector
		category: compiledMethod category
		timeStamp:( compiledMethod timeStampFromFile: file)
		source: (compiledMethod getSourceFromFile: file)! !

!RGMethodDefinition methodsFor: '*Ring-Monticello' stamp: 'CamilloBruni 2/28/2012 20:15'!
basicAsMCMethodDefinition
   "Creates a MCMethodDefinition from the receiver"
   self isActive ifTrue: [ 
		self compiledMethod sourceFileStream ifNotNilDo: [ :file|
			^ self asMCMethodDefinitionFromFile: file]].
	
   ^ MCMethodDefinition
		className: self theNonMetaParentName
 	   	classIsMeta: self isMetaSide
		selector: self selector
		category: self protocol
		timeStamp: self stamp
		source: self sourceCode! !

!MCMethodDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 5/12/2011 13:02'!
asRingDefinition

	^(RGFactory current createMethodNamed:  self selector)
		parentName: self className;
		isMetaSide: self classIsMeta;
		protocol: self category;
		sourceCode: self source;    
		stamp: self timeStamp! !

!MCClassDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 7/14/2011 11:12'!
asRingDefinition
	| ring |

	ring:= (RGFactory current createClassNamed: self className)
		category: self category;
		superclassName: self superclassName;  
		traitCompositionSource: self traitCompositionString;
		addInstanceVariables: self instVarNames;
		addClassVariables: self classVarNames;
		addPoolDictionaries: self poolDictionaries;
		comment: self comment;
		stamp: self commentStamp;
		definitionSource: self definitionString;
		withMetaclass.
	ring theMetaClass 
		traitCompositionSource: self classTraitCompositionString;
		addInstanceVariables: self classInstVarNames;
		definitionSource: self classDefinitionString.
	^ring! !

!MCOrganizationDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 5/12/2011 13:01'!
asRingDefinition

	^RGFactory current createOrganization 
		categories: self categories;
		yourself  ! !

!MCClassTraitDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 7/14/2011 11:24'!
asRingDefinition

	^(RGFactory current createMetatraitNamed: baseTrait)
		traitCompositionSource: self classTraitCompositionString;
		definitionSource: self definitionString;
		yourself! !

!MCClassTraitDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 7/20/2011 15:56'!
classDefinitionString

	^self definitionString! !

!ChangeRecord methodsFor: '*Ring-Monticello' stamp: 'CamilloBruni 5/25/2012 14:28'!
asMCMethodDefinition
	"Creates a MCMethodDefinition from the receiver when this was created for a method (type=#method)"
	
	self type == #method ifFalse: [ ^nil ]. "This case shouldn't happen"
	
	^ MCMethodDefinition 
		className: class
		classIsMeta: meta
		selector: self methodSelector
		category: category
		timeStamp: stamp
		source: self string! !

!MCTraitDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 8/4/2011 14:07'!
asRingDefinition

	| ring |
	ring := (RGFactory current createTraitNamed: self className)
		category: self category;
		superclassName: self superclassName;  
		traitCompositionSource: self traitCompositionString;
		comment: self comment;
		stamp: self commentStamp;
		definitionSource: self definitionString;
		withMetaclass.
		
	ring theMetaClass 
		traitCompositionSource: self classTraitCompositionString;
		definitionSource: self classDefinitionString.
	^ring! !

!MCTraitDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 8/4/2011 11:53'!
classDefinitionString
	"Answer a string describing the class-side definition."
	
	^String streamContents: [:stream | self printMetaDefinitionOn: stream]! !

!MCTraitDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 8/4/2011 12:10'!
classTraitCompositionString
	^self traitComposition 
		ifNil: [ '{}' ]
		ifNotNil: [ :source| | tokens tcs |
			tcs := ''.
			tokens := Scanner new scanTokens: source.
			tokens do:[ :each| 
				each first isUppercase 
					ifTrue: [ tcs := tcs, each, ' classTrait + ' ] ].
			tcs isEmpty 
				ifTrue: [ '{}' ]
				ifFalse:[ tcs copyFrom: 1 to: tcs size - 3 ] ]! !

!MCTraitDefinition methodsFor: '*Ring-Monticello' stamp: 'VeronicaUquillas 8/4/2011 12:11'!
printMetaDefinitionOn: stream

	stream nextPutAll: self className, ' classTrait'; 
		 crtab;
		 nextPutAll: 'uses: ';
		 nextPutAll: self classTraitCompositionString.! !
